/* $Id: spp_arpspoof.h,v 1.1 2001/07/10 02:47:17 roesch Exp $ */
/* Snort Preprocessor Plugin Header File Template */

/* This file gets included in plugbase.h when it is integrated into the rest 
 * of the program.  Sometime in The Future, I'll whip up a bad ass Perl script
 * to handle automatically loading all the required info into the plugbase.*
 * files.
 */
#include "snort.h"

#ifndef __SPP_ARPSPOOF_H__
#define __SPP_ARPSPOOF_H__

typedef struct _IPMacEntry
{
	u_int32_t ipv4_addr;
	u_int8_t  mac_addr[6];
	u_int8_t  pad[2];
} IPMacEntry;

typedef struct _IPMacEntryListNode
{
	IPMacEntry *ip_mac_entry;
	struct _IPMacEntryListNode *next;
} IPMacEntryListNode;

typedef struct _IPMacEntryList
{
	int size;
	IPMacEntryListNode *head;
} IPMacEntryList;

int AddIPMacEntryToList(IPMacEntryList *ipmel, IPMacEntry *ipme);
IPMacEntry *LookupMacEntryByIP(IPMacEntryList *ipmel, u_int32_t ipv4_addr);
void FreeIPMacEntryList(IPMacEntryList *ipmel);

/* list of function prototypes for this preprocessor */
void SetupARPspoof();
void ARPspoofInit(u_char *);
void ParseARPspoofArgs(char *);
void ARPspoofPreprocFunction(Packet *);
void ARPspoofRestartFunction(int);
void ARPspoofCleanExitFunction(int);
void ARPwatchArg(u_char *);

#endif  /* __SPP_ARPSPOOF_H__ */
